:PROPERTIES:
:ID:       2729599d-ae2b-4f22-b73d-bf22d81e0767
:END:
#+title: Test Driven Development
#+filetags: :notes:coding:guide:

Test-driven development is a way of writing code that involves writing an automated unit-level test case that fails, then writing just enough code to make the test pass, then refactoring both the test code and the production code, then repeating with another new test case. Alternative approaches to writing automated tests is to write all of the production code before starting on the test code or to write all of the test code before starting on the production code.

One example is:
- [[id:bca8e7a6-0590-4630-ab49-210306ad21a2][bowling-kata]] 
